import 'package:ev_framework/_FrameWork/Ev/_Image_Get.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';


class $$eeChat_Input extends StatelessWidget {
  var get_image_icon;
  var send_icon;
  var bgcolor;

  var onMessage;
  var onChange;
  var onFile;
  var onPhoto;
  bool hasfile;
  var message = TextEditingController();

  $$eeChat_Input({this.get_image_icon,this.send_icon,this.onPhoto,this.onFile,this.onMessage,this.onChange,this.hasfile=false});

  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.all(5),
      child: Row(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: <Widget>[
        Padding(
          padding: const EdgeInsets.only(top:15,),
          child: _Attach_Icon(context),
        ),
        Expanded(child:_text_chatmessage()),
        Padding(
          padding: const EdgeInsets.only(top:15),
          child: _Send_Icon(context),
        ),
      ],
      )
      );
  }

  Widget _Attach_Icon(BuildContext context)
  {   var icon = get_image_icon;
      if(icon == null)
        { icon = (hasfile) ? Icon(Icons.attach_file,size: 35) : Icon(Icons.photo,size:35);

        }
      if (kIsWeb)
         { icon = get_image_icon ?? Icon(Icons.photo,size:35); }

     return GestureDetector(child: icon,onTap: (){
         //message.text = "";
         FocusScope.of(context).requestFocus(FocusNode());
         if (kIsWeb) {
             $$Image_Get.Get_From_Gallery(context).then((image) {
               onPhoto(image);
           });
         }
         else {
           if(hasfile)
              { $$Image_Get.Get_Select_File(context,onFile); }
             else
                $$Image_Get.Get_Select_Image(context, onReceived: onPhoto);
              }
         }
     );
  }

  Widget _Send_Icon(BuildContext context)
  {  var icon = send_icon ??  Icon(Icons.send,size: 35,);
     return GestureDetector(child: icon, onTap: (){
         if(onMessage != null)
            {  onMessage(message.text); }
         message.text = "";
         FocusScope.of(context).requestFocus(FocusNode());
     },);
  }

  Widget _text_chatmessage() {
    return Material(
      child: Container(
        margin: EdgeInsets.symmetric(horizontal: 5,vertical: 10),
        padding: EdgeInsets.all(0),
        decoration :BoxDecoration(
          border: Border.all(color:Colors.grey,width:1),
          borderRadius: BorderRadius.all(Radius.circular(5)),
       ),


         child: TextField(
           decoration: InputDecoration(
               border: InputBorder.none,
               contentPadding: EdgeInsets.all(5),counterText: ""),
           style:TextStyle(height: 1.2),
           controller: message,
           maxLength: 1000,
           minLines:1,
           keyboardType: TextInputType.multiline,
           maxLines: 4,
           onChanged: onChange,
         ),
        ),
    );
   }
}
