import 'package:ev_framework/_FrameWork/Ev/_PhotoView.dart';
import 'package:flutter/material.dart';
import '../vImage.dart';
import '../vSpace.dart';
import '../vText.dart';
import '_Send_query.dart';


class $$Chat_Send_Photo extends StatefulWidget {
  var url;
  var sdata;
  var post;
  var onSuccess;
  var fontcolor;
  var bgcolor;

  var error = false;
  String error_message;
  var success = false;
  var visible = 0.5;
  var api_loaded = false;

  Send_Query send_query;

  $$Chat_Send_Photo({this.fontcolor,this.bgcolor,this.url,this.post,this.sdata,this.onSuccess,this.send_query,Key key}):super(key:key);

  @override
  _$EV_Send_PhotoState createState() => _$EV_Send_PhotoState();
}

class _$EV_Send_PhotoState extends State<$$Chat_Send_Photo> implements Send_Return {

  var percent = "0%";

  @override
  Widget build(BuildContext context) {
    if(!widget.api_loaded)
       {  widget.api_loaded = true;
          widget.send_query.add(widget.url, widget.post, {"photo":widget.sdata["photo"]}, this);
       }

    if(widget.error)
    {  return Container(
      padding: EdgeInsets.all(5),
      child: Row(children: <Widget>[
        vSp(0).expend(),
        Icon(Icons.error,color: Colors.amber,size: 25,),
        SizedBox(width: 5,),
        //vText(Charroom_send_error[vSystem.$lang_id()]).s1(),
        vText(widget.error_message).s1()
      ],),
      );
    }
    else
    {  return body(context); }
  }


  Widget body(context)
  {  var  w = MediaQuery.of(context).size.width * 0.5 >300 ?  300  :MediaQuery.of(context).size.width * 0.5;

    return GestureDetector(

     child: Card(
          child: ClipRRect(
          borderRadius: BorderRadius.circular(5.0),
           child: Container(
            width: w,
            height: w,
            color: widget.bgcolor,
            padding: EdgeInsets.all(4.0),

            child: Stack(children: <Widget>[
              vImage(image:widget.sdata["photo"]).size(w),
              Positioned(right: 5, bottom: 0,
              child: Padding(
                padding: const EdgeInsets.all(5.0),
                child: Text(widget.sdata["time"],
                    style: TextStyle(fontSize: 10, color: Colors.white)),
              ),),
            (widget.success) ? Container() :
              Container(width: w, height: w,
                color: Colors.black.withOpacity(0.7),
                child:Center(child: Text(percent,style: TextStyle(color:Colors.white,fontWeight: FontWeight.bold))))
            ],),


          )),
    ),

    onTap: (){
        if(widget.success)
          {   Navigator.push(context, MaterialPageRoute(
                builder: (context) => $$PhotoView(image: widget.sdata["photo"])));
          }
     },
  );}

  @override
  void error_return(err_message) {
    setState(() {
      widget.error = true;
      widget.error_message = err_message;
    });
  }

  @override
  void process_return(send, total) {
      print("Proccess $send, $total");
      setState(() {
        percent = (send/total * 99).round().toString() + "%";
      });
  }

  @override
  void success_return(data) {
     setState(() {
        widget.success = true;
        widget.onSuccess(data);
     });
  }
}
