import 'dart:io';
import 'package:flutter/material.dart';
import '../vApi.dart';
import '_Chat_View.dart';

class Send_Return {
   void success_return(data) {}
   void error_return(String err_message) {}
   void process_return(send,total){}

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return null;
  }
}

class _Send_API {
  var url;
  var post;
  Map<String,File> file_post;
  Send_Return se;

  _Send_API(this.url,this.post,this.file_post,this.se);
}

class Send_Query
{
    List<_Send_API> query = List();
    vApi api = vApi();
    bool action = false;
    $$eChat_View chat_view;

    Send_Query({this.chat_view});


    void add(url,post,Map<String,File> file_post,Send_Return se) {
      //print("Add Query : " + post.toString() + file_post.toString());
      var new_query = _Send_API(url, post, file_post, se);
      query.add(new_query);
      _query_action();
    }

   void _query_action()
   {  if(!action && query.length>0) {
       action = true;
       _Send_API a = query[0];
       //print("Query action :" + a.post.toString());
       a.post["last_id"] = chat_view.last_id.toString();

       api.$post(a.url, postValue: a.post,
          uploadValue: a.file_post,
          onProgress: a.se.process_return,
          onError: (){ _onNotConnect(a);},
          onData: (data){
                //print("API on success " + a.post.toString());
                _onSuccess(a,data);
       });
    }}

   void _onNotConnect(_Send_API a)
   {  action = false;
      query.remove(a);
      a.se.error_return("Cannot Connect Server");
      _query_action();
   }

   Future _onSuccess(_Send_API a,data)
   async {  action = false;
      query.remove(a);
      if(data["status"]==0)
        a.se.error_return(data["err_message"]);
      else
        a.se.success_return(data);

      _query_action();
   }

   void dispose()
   {  api.$Stop(); }


}
