import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;

class $$Api_Builder extends StatefulWidget {
  var api;
  var onData;
  var post;
  var snapdadta;

  $$Api_Builder({this.api,this.onData,this.post});

  @override
  _$$Api_BuilderState createState() =>  _$$Api_BuilderState();
}

class _$$Api_BuilderState extends State<$$Api_Builder> {

  void initState() {
   }

  @override
  void dispose() {
     super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    if(widget.snapdadta == null)
      return FutureBuilder(
        future: future_api(),
        builder: (context, Snap) {
          if (Snap.connectionState == ConnectionState.done) {
            if (Snap.hasError) {
              return Center(child: Column(
                children: [
                  Icon(Icons.error_outline, color: Colors.yellow, size: 100),
                ],
              ));
            }
            else {
              return widget.onData(widget.snapdadta);
            }
          }
          else {
            return AspectRatio(aspectRatio: 1.5,
              child: Center(
                child: Container(
                  width: 50,height: 50,
                  padding: const EdgeInsets.all(10.0),
                  child: CircularProgressIndicator(),
                ),
              ),
            );
          }
        });
     else
       {  return widget.onData(widget.snapdadta); }
  }

  Future future_api() async {
    var response = await http.post(Uri.parse(widget.api),body: widget.post);
    if (response.statusCode == 200) {
       widget.snapdadta = jsonDecode(response.body);
       return widget.snapdadta;
    } else {
      throw Exception('Failed to load album');
    }
  }
}
