import 'package:carousel_pro/carousel_pro.dart';
import 'package:flutter/material.dart';
import '../vImage.dart';
import '../vSystem.dart';

class $$ImageSlide extends StatefulWidget {
  List Images;
  List Url;
  var size_radio;

  bool show_dot;
  Color dot_color;
  bool autoplay;

  $$ImageSlide({this.Images,this.size_radio =1.5, this.Url,this.show_dot=false,this.dot_color = Colors.white,this.autoplay = false});

  @override
  _$$ImageSlidvImageState createState() => _$$ImageSlidvImageState();
}

class _$$ImageSlidvImageState extends State<$$ImageSlide> {

  var current_page = 0;

  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    if(widget.Images.length ==0)
      {  return AspectRatio(child: Container(color: Colors.grey,width: double.infinity, height: double.infinity), aspectRatio: widget.size_radio,); }

    if (widget.Images.length == 1) {
      return Single_Image();
    }
    else {
      return Multi_Images();
    }
  }

  Widget Single_Image() {
    if(widget.Url!=null) {
      return vImage(image : widget.Images[0]).onPress(() {
        vSystem.$open_URL(widget.Url[0]);
      }).ratio(widget.size_radio);
    }
    else
     {  return vImage(image:widget.Images[0]).ratio(widget.size_radio); }
  }

  Widget Multi_Images() {
    return AspectRatio(
      aspectRatio: widget.size_radio,
      child: Carousel(
        images: widget.Images.map<dynamic>((e) => NetworkImage(e)).toList(),
        showIndicator: true,
        dotSize: 7.0,
        dotSpacing: 20.0,
        dotColor: widget.dot_color,
        indicatorBgPadding: 10.0,
        dotBgColor: Colors.grey.withOpacity(0.0),
        autoplay: widget.autoplay,
        //borderRadius: false,
        //moveIndicatorFromBottom: 180.0,
        //noRadiusForIndicator: true,
        //overlayShadow: false,
        //overlayShadowColors: Colors.white,
        //overlayShadowSize: 1.7,
        onImageTap:(index){
           if(widget.Url[index] != null)
             {  vSystem.$open_URL(widget.Url[index]); }
        } ,
      ),
    );
  }
}