import 'dart:ui';
import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import './vSystem.dart';
import 'Ev/_Image_Get.dart';
import 'vController.dart';
import 'vImage.dart';
import 'vText.dart';

class vButton extends StatefulWidget {

  static Color $TextColor = Colors.white;
  static Color $ButtonColor = Colors.blue;
  static Color $Hover_Color = Colors.yellow;
  static Color $OnTap_Color = Colors.yellow;
  static double $FontSize  = 18;
  static double $Round = 3;

  var text;
  double _fontsize = $FontSize;
  Color _text_color;
  Color _hover_color;
  Color _onTap_color;
  bool _no_effect = false;
  bool _remove = false;

  IconData _icon;
  String _assert_image;

  Color _button_color;
  String sKey;

  _vButtonState _stateitem;

  double _width = null;
  double _height = null;
  var _padding = EdgeInsets.all(0);
  var _margin = EdgeInsets.all(4);

  //var _webMarginOffset = kIsWeb ? 4 : 0;
  //var _webPpaddingOffset = kIsWeb ? 6 : 0;

  var _webMarginOffset = kIsWeb ? 0 : 0;
  var _webPpaddingOffset = kIsWeb ? 0 : 0;

  double _crop_ratio = 0;
  double _opacity = 1.0;
  double _round;
  bool _shadow = false;
  var _device_hide = [0,0,0,0,0,0];

  var _onpress = null;
  var _onpress_type = 0;

  bool _outline = false;

  Color _outline_backgound = Colors.transparent;

  vButton(this.text,{this.sKey="0"});

  vButton c(Color button_Color)
  { this._button_color = button_Color;  return this;}

  vButton cw()
  { this._button_color = Colors.white;  return this;}

 vButton noEffect()
 {  this._no_effect = true; return this;}


  vButton fontsize(double fontsize)
  { this._fontsize = fontsize;  return this;}


  vButton onOver_c(Color hover_Color) {
    this._hover_color = hover_Color;
    return this;
  }

  vButton onTap_c(Color onTap_Color) {
    this._onTap_color = onTap_Color;
    return this;
  }

  vButton tc(Color text_color)
  { this._text_color = text_color;  return this;}

  vButton icon(IconData icon)
  { this._icon = icon;  return this;}

  vButton img(String assert_image)
  { this._assert_image = assert_image;  return this;}

  vButton r(double round)
   { this._round = round;  return this;}

  vButton rf()
  { this._round = 1000;  return this;}

  vButton w(double width)
   { this._width = width; return this;}

  vButton wh(double width,double height)
  { this._width = width;
    this._height = height;
    return this;
  }

  vButton wf()
  { this._width = double.infinity;  return this;}

  vButton h(double height)
   { this._height = height; return this; }

  vButton p(double padding_value)
  { this._padding = EdgeInsets.all(padding_value + _webPpaddingOffset ); return this; }

  vButton px(double padding_value)
  { this._padding = EdgeInsets.symmetric(horizontal: padding_value + _webPpaddingOffset);  return this;}

  vButton py(double padding_value)
  { this._padding = EdgeInsets.symmetric(vertical: padding_value + _webPpaddingOffset);  return this;}

  vButton pxy(double xpadding,ypadding)
  { this._padding = EdgeInsets.symmetric(horizontal: xpadding + _webPpaddingOffset , vertical: ypadding + _webPpaddingOffset);  return this;}

  vButton m(double margin_value)
  { this._margin = EdgeInsets.all(margin_value + _webMarginOffset); return this; }

  vButton mx(double margin_value)
  { this._margin = EdgeInsets.symmetric(horizontal: margin_value + _webMarginOffset);  return this;}

  vButton my(double margin_value)
  {
     this._margin = EdgeInsets.symmetric(vertical: margin_value + _webMarginOffset);  return this;}

  vButton mxy(double xmargin,ymargin)
  {
    this._margin = EdgeInsets.symmetric(horizontal: xmargin + _webMarginOffset,
        vertical: ymargin + _webMarginOffset);  return this;}

  vButton shadow()
  { this._shadow = true;  return this;}

  vButton outline({Color backgound = Colors.transparent})
    {  this._outline = true;
       this._outline_backgound = backgound;
       return this;
    }

  vButton onPress(f)
  {  this._onpress = f;
     this._onpress_type = 0;
     return this;}

  vButton onGetimage(f,{crop_ratio = 0})
  {   this._onpress = f;
      this._onpress_type = 1;
      this._crop_ratio = _crop_ratio;
      return this;
  }

  vButton onGetFile(f)
  {    this._onpress = f;
       this._onpress_type = 2;
       return this;
  }


  static vButton $skey(String k)
  {   return $$vController.button_items[k]; }


  void $hide()
  {  _remove = false;
     _stateitem.show(0.0); }

  void $show()
  {  _remove = false;
     _stateitem.show(1.0); }

  void $remove()
   {  _stateitem.setState(() {
       _remove = true;
      });
   }

  void $text(String text)
  {  _stateitem.setState(() {
      this.text = text;
     });
  }

  void $enable()
   {  _stateitem.enable(true); }

  void $disable()
   {  _stateitem.enable(false); }


  vButton hide({bool mobile=false,bool tablelet=false,bool destop=false,bool large=false})
  {  this._device_hide[0] = mobile ? 1 : 0;
     this._device_hide[1] = tablelet ? 1 : 0;
     this._device_hide[2] = destop ? 1 : 0;
     this._device_hide[3] = large ? 1 : 0;
     return this;
  }

  vButton h_M()
  {  this._device_hide[0] = 1; return this; }

  vButton h_T()
  { this._device_hide[1] = 1; return this; }

  vButton h_D()
  { this._device_hide[2] = 1; return this; }

  vButton h_L()
  { this._device_hide[3] = 1; return this; }


  @override
  _vButtonState createState() {
   _stateitem = _vButtonState();
    return _stateitem;
  }
}

class _vButtonState extends State<vButton> {
  var _enable = true;
  var _onOver = false;
  var _onTap = false;

  void initState() {
    //print("Init " + widget.toString());
    $$vController.button_items[widget.sKey] = widget;
  }

  @override
  void dispose() {
    // TODO: implement dispose
    //print("Dispose " + widget.sKey);
    //$$vController.button_items[widget.sKey] = widget;
    super.dispose();
  }


  void enable(bool isenable) {
    setState(() {
      _enable = isenable;
      _onOver = false;
      _onTap = false;
      widget._opacity = isenable ? 1.0 : 0.6;
    });
  }

  void show(opacity) {
    setState(() {
      widget._opacity = opacity;
    });
  }

  @override
  Widget build(BuildContext context) {
    if (widget._remove) {
      return Container();
    }

    Widget bchild = Opacity(
        opacity: widget._opacity,
        child: Padding(padding: widget._margin,
            child: button(),
    ));

    if (widget._device_hide.reduce((a, b) => a + b) > 0) {
      return LayoutBuilder(
          builder: (context, constraints) {
            var sid = vSystem.screensize_ID(context);
            if (widget._device_hide[sid] == 1) {
              return Container();
            }
            else {
              return bchild;
            }
          });
    }
    else {
      return bchild;
    }
  }

 Widget button() {
   var textcolor = widget._text_color ?? vButton.$TextColor;
   var buttoncolor = widget._button_color ?? vButton.$ButtonColor;
   var color = widget._outline ? widget._outline_backgound : buttoncolor;

   if(widget._no_effect || widget._onpress==null)
      {}
   else {
     if (_onTap) {
       color = widget._onTap_color ?? vButton.$OnTap_Color;
     }
     if (_onOver) {
       color = widget._hover_color ?? vButton.$Hover_Color;
     }
   }

   var decoration = BoxDecoration(
     border: Border.all(
       color: buttoncolor,
       width: 2,
     ),

     color: color,

     borderRadius: BorderRadius.all(Radius.circular(widget._round ?? vButton.$Round)),
     boxShadow: widget._shadow && !_onTap ?
     [ BoxShadow(
       color: Colors.black.withOpacity(0.3),
       blurRadius: 5,
       offset: Offset(3, 3), // changes position of shadow
     ),
     ] : null,
   );

   Widget c = vText(widget.text).size(widget._fontsize).c(widget._outline ? buttoncolor : textcolor).ac().pxy(widget._fontsize, widget._fontsize/4);

   if (widget._icon != null) {
     c = Row(
       children: [
       Expanded(child:Container()),
       Icon(widget._icon, size: 25, color: widget._outline ? buttoncolor : textcolor,),
       c,
       Expanded(child:Container()),
     ],);
   }

   if (widget._assert_image != null) {
     c = Row(children: [
       Expanded(child:Container()),
       vImage(image: widget._assert_image).size(20).mx(5).box_contain(),
       c,
       Expanded(child:Container()),
     ],);
   }

   Widget output_child = Container(padding: widget._margin, color: Colors.transparent,
    child: Container(
     padding: widget._padding,
     width: widget._width,
     height: widget._height,
     child: c,
     decoration: decoration,
   ));

   //print("Button disable " + _enable.toString());
   if(_enable && widget._onpress!=null)
   { output_child = Material(
     color: Colors.transparent,
     child: InkWell(
         hoverColor: Colors.transparent,
         highlightColor: Colors.transparent,
         splashColor: Colors.transparent,
         onTapDown: (TapDownDetails details) {
           setState(() {
             _onTap = true;
           });
         },
         onTap: () {
           setState(() {
             //print("On Press");
             _onTap = false;
             onpress();
           });
         },
         onHover: (isHovering) {
           setState(() {
             _onOver = isHovering;
             if (!isHovering) {
               _onTap = false;
             }
           });
         },

         child: output_child),
    );}

   return output_child;
 }


  void onpress() {
    switch (widget._onpress_type) {
      case 0:
        widget._onpress();
        break;

      case 1:
        if (kIsWeb) {
          $$Image_Get.Get_From_Gallery(context, crop_ratio: 0).then((image) {
            widget._onpress(image);
          });
        }
        else {
          $$Image_Get.Get_Select_Image(context, onReceived: widget._onpress,crop_ratio: widget._crop_ratio);
        }
        break;

      case 2:
        if (kIsWeb) {
          $$Image_Get.Get_From_Gallery(context, crop_ratio: 0).then((image) {
          widget._onpress(image);
         });
        }
        else {
          $$Image_Get.Get_Select_File(context, widget._onpress);
       }
      break;
    }
  }
}