import 'dart:io';
import 'package:firebase_core/firebase_core.dart';
import 'package:firebase_messaging/firebase_messaging.dart';

class FireBase_CallBack
{   FireBase_OnMessage(dynamic message){} }


class vFirebase
{  static String token = "";
   static List<FireBase_CallBack> callbacklist = [];

   static void initState_CallBack(FireBase_CallBack callback)
    {  callbacklist.add(callback); }

   static void dispose(callback)
    {  callbacklist.remove(callback); }

   static Future connect(String topic) async {
    await Firebase.initializeApp();
    print("FireBase Connect");
    if (Platform.isIOS) iOS_Permission();

  var token = await  FirebaseMessaging.instance.getToken();
  vFirebase.token = token;
  print("FireBase token $token");

  await FirebaseMessaging.instance.setForegroundNotificationPresentationOptions(
    alert: true,
    badge: true,
    sound: true,
  );

  FirebaseMessaging.onMessage.listen((RemoteMessage message)
      {  print('FireBase on message $message');
         if(callbacklist.length>0)
          {  for(var i=0;i<callbacklist.length;i++)
               { callbacklist[i].FireBase_OnMessage(message.data); }
          }
      });

  if(topic !="")
   {  await FirebaseMessaging.instance.subscribeToTopic(topic); }

  return token;
}

static Future Get_Token() async
{  if (token == "") {
      var tok = await FirebaseMessaging.instance.getToken();
      token = tok;
    }
   return token;
}

static Future<void> set_topic(String topic)
 async {  await FirebaseMessaging.instance.subscribeToTopic(topic); }

static Future<void> unset_topic(String topic)
async {  await FirebaseMessaging.instance.unsubscribeFromTopic(topic); }


static void iOS_Permission() {
  FirebaseMessaging.instance.requestPermission(
    alert: true,
    announcement: false,
    badge: true,
    carPlay: false,
    criticalAlert: false,
    provisional: false,
    sound: true,
  );}
}

