import 'package:flutter/material.dart';
import 'Ev/_Form_Date.dart';
import 'Ev/_Form_DropDown.dart';
import 'Ev/_Form_Item.dart';
import 'Ev/_Form_Select.dart';
import 'Ev/_Form_onOff.dart';
import 'vSystem.dart';

const  Map<String, String> TextEdit_error_email = {'1': 'Invalid Email', '2': '電郵地址不正確', '3': '电邮地址不正确'};
const  Map<String, String> TextEdit_error_mobile = {'1': 'Invalid Tel', '2': '電話號碼不正碓', '3': '電話號碼不正碓'};
const  Map<String, String> TextEdit_error_number = {'1': 'Invalid Number', '2': '輸入不正碓', '3': '输入不正碓'};
const  Map<String, String> TextEdit_error_date = {'1': 'Invalid Date Formate (YYYY-MM-DD)', '2': '日期格式不正確 (YYYY-MM-DD)', '3': '日期格式不正确 (YYYY-MM-DD)'};
const  Map<String, String> TextEdit_error_confirm_password = {'1': 'Confirm password not correct ', '2': '確認密碼不正確','3': '确认密码不正确'};
const  Map<String, String> TextEdit_error_password = {'1': 'Must be 8-20 characters', '2': '必需為 8 - 20 個字元', '3': '必需为 8 - 20 个字元'};
const  Map<String, String> TextEdit_password_hint = {'1': '8-20 characters', '2': '8 - 20 個字元', '3': '8 - 20 个字元'};
const  Map<String, String> TextEdit_error_over = {'1': 'Must more then #1 characters', '2': '必須輸入 #1 個字元以上', '3': '必须输入 #1 个字元以上'};
class _vForm_Border_Type {
  static const Line = 1;
  static const Border = 2;
  static const NoBorder = 0;
}

class vForm
{    static Color $Lable_Color = Colors.black;
     static double $Lable_Size = 16;
     static int $Border_type = 1;
     static Color $Border_Color = Colors.grey;
     static double $Border_Width = 0;
     static Color $Bg_Color = Colors.white;

     static double $Input_Size = 16;
     static Color $Input_Color = Colors.black;
     static int $Lable_Position = 0;
     static double $Lable_ratio = 0;
     static Color $Dropdown_BG_Colors = Colors.white;

     static double $Round = 0;
     static var $Padding = EdgeInsets.symmetric(vertical: 0,horizontal: 0);
     static var $Margin = EdgeInsets.all(5);

     static TextAlign $Text_Align = TextAlign.left;

     Color $$_Lable_Color;
     double $$_Lable_Size;
     int $$_Border_type ;
     Color $$_Border_Color;
     double $$_Border_Width;
     double $$_Lable_ratio;
     double $$_Input_Size;
     Color $$_Input_Color;
     int $$_Lable_Position;
     double $$_Round;
     Color $$_Bg_Color;
     Color $$_Dropdown_BG_Colors;

     var $$_Padding;
     var $$_Margin;
     var $$_Text_Align;

     Map<String,TextEditingController> _textcontroller  = Map<String,TextEditingController>();
     Map<String,GlobalKey<State>> _statekey  = Map();


     Map<String,String> $$_item_error  = Map<String,String>();
     Map<String,List> _checkvalid  = Map<String,List>();


    vForm input_style({double text_size=16,Color text_Color=Colors.black54})
     { this.$$_Input_Size = text_size;
       this.$$_Input_Color = text_Color;
       return this;
     }


     vForm input_line({Color line_Color})
      { this.$$_Border_type = _vForm_Border_Type.Line;
        this.$$_Border_Color = line_Color;
        return this;
      }

    vForm input_border({Color border_Color,double border_Width = 1,double border_Round = 0})
      { this.$$_Border_type = _vForm_Border_Type.Border;
        this.$$_Border_Color = border_Color;
        this.$$_Border_Width = border_Width;
        this.$$_Round = border_Round;
        return this;
      }

    vForm bgcolor(Color color)
    { this.$$_Bg_Color = color;
      return this;
    }


    vForm border_color(Color color)
     { this.$$_Border_Color = color;
        return this;
     }

    vForm dropdown_bgcolor(Color color)
    { this.$$_Dropdown_BG_Colors = color;
      return this;
    }

    vForm noborder() {
      this.$$_Border_type = 0;
      return this;
    }

    vForm r(double round) {
      this.$$_Round = round;
      return this;
    }


    vForm ac() {
      this.$$_Text_Align = TextAlign.center;
      return this;
    }

    vForm ar() {
      this.$$_Text_Align = TextAlign.right;
      return this;
    }

    vForm al() {
      this.$$_Text_Align = TextAlign.left;
      return this;
   }

    vForm label_ratio(double ratio)
    { this.$$_Lable_ratio = ratio;
      return this;
    }

    vForm p(double padding_value)
    { this.$$_Padding = EdgeInsets.all(padding_value); return this; }

    vForm px(double padding_value)
    { this.$$_Padding = EdgeInsets.symmetric(horizontal: padding_value);  return this;}

    vForm py(double padding_value)
    { this.$$_Padding = EdgeInsets.symmetric(vertical: padding_value);  return this;}

    vForm pxy(double horizontal,double vertical)
    { this.$$_Padding = EdgeInsets.symmetric(horizontal: horizontal, vertical: vertical);  return this;}

   vForm m(double margin_value)
     { this.$$_Margin = EdgeInsets.all(margin_value); return this; }

   vForm mx(double margin_value)
    { this.$$_Margin = EdgeInsets.symmetric(horizontal: margin_value);  return this;}

   vForm my(double margin_value)
   { this.$$_Margin = EdgeInsets.symmetric(vertical: margin_value);  return this;}

   vForm mxy(double horizontal,double vertical)
    { this.$$_Margin = EdgeInsets.symmetric(horizontal: horizontal, vertical: vertical);  return this;}


    vForm label_style(double lable_size,Color lable_color)
      {  this.$$_Lable_Size  = lable_size;
         this.$$_Lable_Color = lable_color;
         return this;
      }

    /*
    vForm lable_outside()
    {   $$_Lable_Position = vForm_Label_Postion.Outside;
        return this;
    }

    vForm lable_inside()
      {   $$_Lable_Position = vForm_Label_Postion.Inside;
          return this;
      }
    */

    void _init_var() {
      $$_Lable_Color = $$_Lable_Color ?? vForm.$Lable_Color;
      $$_Lable_Size = $$_Lable_Size ?? vForm.$Lable_Size;
      $$_Border_type = $$_Border_type ?? vForm.$Border_type;
      $$_Border_Color = $$_Border_Color ?? vForm.$Border_Color;
      $$_Border_Width = $$_Border_Width ?? vForm.$Border_Width;
      $$_Input_Size = $$_Input_Size ?? vForm.$Input_Size;
      $$_Lable_Position = $$_Lable_Position ?? vForm.$Lable_Position;
      $$_Round = $$_Round ?? vForm.$Round;
      $$_Padding = $$_Padding ?? vForm.$Padding;
      $$_Text_Align = $$_Text_Align ?? vForm.$Text_Align;
      $$_Margin = $$_Margin ?? vForm.$Margin;
      $$_Lable_ratio = $$_Lable_ratio ?? vForm.$Lable_ratio;
      $$_Bg_Color = $$_Bg_Color ?? vForm.$Bg_Color;
      $$_Dropdown_BG_Colors = $$_Dropdown_BG_Colors ?? vForm.$Dropdown_BG_Colors;
    }


    /*
   void init_value(String key,s,textcontroller)
   {  _textcontroller[key] = textcontroller;
       _state_list.add(s);
       _state_id[key] = _state_list.length - 1;
       print("init value:" + _state_list.toString() + _state_id.toString());
   }

     */

    Widget $Hidden(String key,String value)
    {    _textcontroller[key] = TextEditingController(text:value); }


    Widget $Date(String key,{label_text="", value ="",max_length=500, check_empty = true,start_date,end_date,color=Colors.blue})
       {    _init_var();
              _checkvalid[key] = [];
              _checkvalid[key].add((key) {
                var value = _textcontroller[key].text;
                if (DateTime.tryParse(value) == null) {
                  $$_item_error[key] = TextEdit_error_date[vSystem.$lang_id()];
                  return false;
                }
               else {
                  final date = DateTime.parse(value);
                  final y = date.year.toString().padLeft(4, '0');
                  final m = date.month.toString().padLeft(2, '0');
                  final d = date.day.toString().padLeft(2, '0');
                  if (value != "$y-$m-$d") {
                    $$_item_error[key] =
                    TextEdit_error_date[vSystem.$lang_id()];
                    return false;
                  }}
              return true;
           });
           if(check_empty)
             {    _checkvalid[key].add(_checkempty); }

       if(_textcontroller[key]  == null)
       {  _textcontroller[key] = TextEditingController(text:value); }

          _statekey[key] = GlobalKey();
          return $$Form_Date(_statekey[key],key,this,_textcontroller[key].text,_textcontroller[key],label_text: label_text
            ,start_date: start_date,end_date: end_date,color:color);
     }


   Widget $Text(String key,{label_text="", value ="", hinttext = "",max_length=500, min_length=0, check_empty = true,icon,onChange,TextAlign textAlign,onCheckValid,onSubmit})
    {    _init_var();
         if((check_empty || min_length>0 || onCheckValid != null) && _checkvalid[key] == null)
           {  _checkvalid[key] = [];
              if(onCheckValid != null)
               {  _checkvalid[key].add((key){
                    var result_text = onCheckValid(_textcontroller[key].text);
                    if(result_text=="")
                    {  return true; }
                  else {
                    $$_item_error[key] = result_text;
                    return false;
                  }});
               };

            if(min_length>0)
                {  _checkvalid[key].add((key){
                     if(_textcontroller[key].text.length < min_length) {
                        $$_item_error[key] = TextEdit_error_over[vSystem.Lang_id].replaceAll("#1", "$min_length");
                        return false;
                    }
                    return true;
                 });}

             if(check_empty)
               { _checkvalid[key].add(_checkempty); }
           }

          if(_textcontroller[key]  == null)
            {  _textcontroller[key] = TextEditingController(text:value); }

         _statekey[key] = GlobalKey();
         return $$Form_text(_statekey[key],key,this,_textcontroller[key].text,_textcontroller[key],label_text: label_text,hinttext: hinttext,maxlength: max_length,keyboard_type: TextInputType.text,icon:icon,onChange: onChange,text_align: textAlign,onSubmit: onSubmit,);
    }

   Widget $DropDown(String key,Map IdValue,double Width,{label_text="", value_id="",  onChange,check_empty = true})
      {   _init_var();
         if(check_empty && _checkvalid[key] == null)
          {  _checkvalid[key] = [];
             _checkvalid[key].add((key){
               if(_textcontroller[key].text=="0") {
                   $$_item_error[key] = "";
               return false;
             }
               return true;
          });}

      if(_textcontroller[key]  == null)
      {  _textcontroller[key] = TextEditingController(text:value_id); }

          _statekey[key] = GlobalKey();
         return $$Form_DropDown(_statekey[key],key,this,_textcontroller[key].text
             ,_textcontroller[key],Width,label_text: label_text,map_data: IdValue,onchange: onChange,);
     }

   Widget $SelectList(String key,List data,{label_text="", value="", check_empty = true, onChange,max_select=1,max_select_error = "Select too more!"})
       {   _init_var();
          if(check_empty && _checkvalid[key] == null)
            {  _checkvalid[key] = [];
               _checkvalid[key].add(_checkempty);
            }

        if(_textcontroller[key]  == null)
          {  _textcontroller[key] = TextEditingController(text:value); }

          _statekey[key] = GlobalKey();
          return $$Form_Select(_statekey[key],key,this,_textcontroller[key].text,_textcontroller[key],label_text: label_text, data: data, onchange: onChange,max_select: max_select,max_select_error: max_select_error,);
      }

   Widget $OnOff(String key,{label_text,value="0",color = Colors.lightBlue,onChange})
      {   _init_var();
          _textcontroller[key] = TextEditingController(text:value);
          _statekey[key] = GlobalKey();
          return $$Form_OnOff(_statekey[key],key,this,value,_textcontroller[key],label_text: label_text,color: color, onchange: onChange,);
      }

   Widget $Number(String key,{label_text="", value ="", hinttext = "",  min=-99999999, max=99999999,check_empty = true,icon,onChange,TextAlign textAlign,onSubmit})
     {    _init_var();
        if(check_empty && _checkvalid[key] == null)
          {  _checkvalid[key] = [];
             _checkvalid[key].add((key){
             if(num.tryParse(_textcontroller[key].text.toString()) == null) {
               $$_item_error[key] = TextEdit_error_number[vSystem.$lang_id()];
               return false;
           }
        else
           {  var n = num.parse(_textcontroller[key].text.toString());
              if(n<min || n>max)
                {  $$_item_error[key] = TextEdit_error_number[vSystem.$lang_id()];
                    return false;
                 }
            }

          return true;
          });
           _checkvalid[key].add(_checkempty);
         }

     if(_textcontroller[key]  == null)
     {  _textcontroller[key] = TextEditingController(text:value); }

        _statekey[key] = GlobalKey();
        return $$Form_text(_statekey[key],key,this,_textcontroller[key].text,_textcontroller[key],label_text: label_text,hinttext: hinttext,maxlength: 20,keyboard_type: TextInputType.number,onChange: onChange,text_align: textAlign,onSubmit: onSubmit,);
    }

    Widget $Phone(String key,{label_text="", value ="", hinttext = "", check_empty = true, icon,onChange,onSubmit})
     {    _init_var();
         if(check_empty && _checkvalid[key] == null)
           {  _checkvalid[key] = [];
              _checkvalid[key].add((key){
                 var t = _textcontroller[key].text.toString();
                 if(t.length>0)
                   {  if(int.tryParse(t) != null) {
                     var m = int.parse(t);
                     if (m < 20000000 || m > 99900000) {
                       $$_item_error[key] =
                       TextEdit_error_mobile[vSystem.$lang_id()];
                       return false;
                     }
                     else {
                       return true;
                     }
                   }
                   else
                     {  $$_item_error[key] = TextEdit_error_mobile[vSystem.$lang_id()];
                        return false;
                     }
                   }
                 return true;
              });
              _checkvalid[key].add(_checkempty);
           }
       if(_textcontroller[key]  == null)
         {  _textcontroller[key] = TextEditingController(text:value); }

         _statekey[key] = GlobalKey();
         return $$Form_text(_statekey[key],key,this,_textcontroller[key].text,_textcontroller[key],label_text: label_text,hinttext: hinttext,maxlength: 20,keyboard_type: TextInputType.phone,onChange: onChange,onSubmit: onSubmit,);
     }

    Widget $Textarea(String key,{label_text="", value ="", hinttext = "",max_length = 2000, min_length=0, min_line=1,max_line=4,check_empty = true})
    {    _init_var();
     if((check_empty || min_length>0) && _checkvalid[key] == null)
        {  _checkvalid[key] = [];
           if(min_length>0)
             {  _checkvalid[key].add((key){
                if(_textcontroller[key].text.length < min_length) {
                    $$_item_error[key] = TextEdit_error_over[vSystem.Lang_id].replaceAll("#1", "$min_length");
                    return false;
                 }
                 return true;
              });

          }
    _checkvalid[key].add(_checkempty);

    }
    if(_textcontroller[key]  == null)
    {  _textcontroller[key] = TextEditingController(text:value); }

         _statekey[key] = GlobalKey();
         return $$Form_text(_statekey[key],key,this,_textcontroller[key].text,_textcontroller[key],
             max_line: max_line, min_line: $$_Border_type == 1 ? 1 : min_line,
             label_text: label_text,hinttext: hinttext,maxlength: max_length,keyboard_type: TextInputType.multiline,);
}

  Widget $TextReadonly({label_text="", value ="",Color text_color})
    {    _init_var();
          _textcontroller["0"] = TextEditingController(text:value);
          return $$Form_text(GlobalKey(),"0",this,value, _textcontroller["0"],label_text: label_text,readonly: true, textcolor:text_color);
    }


   Widget $Email(String key,{label_text="", value ="", hintext = "", check_empty = true,icon,onChange,onSubmit})
   {    _init_var();
       if(check_empty && _checkvalid[key] == null)
         {  _checkvalid[key] = [];
            _checkvalid[key].add((key){
               var value = _textcontroller[key].text;
               if(!RegExp(r"^[a-zA-Z0-9.a-zA-Z0-9.!#$%&'*+-/=?^_`{|}~]+@[a-zA-Z0-9-]+\.[a-zA-Z]+").hasMatch(value))
                  {  $$_item_error[key] = TextEdit_error_email[vSystem.$lang_id()];
                     return false;
                  }
               return true;
              });
            if(check_empty)
              { _checkvalid[key].add(_checkempty); }
         }

     if(_textcontroller[key]  == null)
       {  _textcontroller[key] = TextEditingController(text:value); }

         _statekey[key] = GlobalKey();
        return $$Form_text(_statekey[key],key,this,_textcontroller[key].text,_textcontroller[key],hinttext:hintext, label_text: label_text,maxlength: 200,keyboard_type: TextInputType.emailAddress,icon:icon,onChange: onChange, onSubmit: onSubmit,);
   }


    Widget $Password(String key,{label_text="", value ="",icon})
    {    _init_var();

        if(_checkvalid[key] == null)
           {  _checkvalid[key] = [];
              _checkvalid[key].add(_checkpassword);
              _checkvalid[key].add(_checkempty);

           }

        _textcontroller[key] = TextEditingController(text:value);
         _statekey[key] = GlobalKey();
         return $$Form_text(_statekey[key],key,this,value,_textcontroller[key],label_text: label_text,
             hinttext: TextEdit_password_hint[vSystem.$lang_id()],maxlength:20,keyboard_type: TextInputType.text,ispassword: true,icon: icon,);
    }

    Widget $ConfirmPassword(String key,String parent_password_key,{label_text="",icon})
      {    _init_var();
          if(_checkvalid[key] == null)
            {  _checkvalid[key] = [];
               _checkvalid[key].add((skey){
                      if(_textcontroller[key].text != _textcontroller[parent_password_key].text) {
                        $$_item_error[key] =
                        TextEdit_error_confirm_password[vSystem.$lang_id()];
                        return false;
                      }
                      return true;
                });
               _checkvalid[key].add(_checkpassword);
               _checkvalid[key].add(_checkempty);

             }

          _textcontroller[key] = TextEditingController();
          _statekey[key] = GlobalKey();
          return $$Form_text(_statekey[key],key,this,"",_textcontroller[key],label_text: label_text,
           hinttext: TextEdit_password_hint[vSystem.$lang_id()],maxlength:20,keyboard_type: TextInputType.text,ispassword: true,icon:icon);
       }



bool _checkempty(key) {
  var valid = true;
  if(_textcontroller[key].text.toString().isEmpty ||   _textcontroller[key].text.trimLeft().isEmpty ||   _textcontroller[key].text.trimRight().isEmpty) {
    $$_item_error[key] = "";
    valid = false;
  }
  return valid;
}


  bool _checkpassword(key) {
     //print("Check password $key");
     var valid = true;
     var value =  _textcontroller[key].text.toString();

     if (value.length < 8 || value.length > 20) {
        $$_item_error[key] = TextEdit_error_password[vSystem.$lang_id()];
        valid = false;
     }
    //print("Check password $key : Valid:" + valid.toString()  +  " Error:" + $$_item_error[key].toString());
    return valid;
  }


   bool $checkvalid()
   {  var valid = true;
      //print("Form check valid");
      $$_item_error = Map();
      _checkvalid.keys.forEach((key) {
          for(var n=0;n<_checkvalid[key].length;n++) {
            if(_statekey[key].currentState != null)
             {  if (!_checkvalid[key][n](key)) {
                  valid = false;
                  //print("Error $key " + $$_item_error[key].toString());
               }

             _statekey[key].currentState.setState(() {
               //print("Form Key $key : " +  _textcontroller[key].text);
              });
             }
          }
      });
     return valid;
   }

   String $get_error(String key)
   {  return $$_item_error[key] ?? "" ; }

   String $get(String key)
    {  return _textcontroller[key]==null ? "" : _textcontroller[key].text; }


 void $set(String key,String value) {
  if(_textcontroller[key] == null)
    { _textcontroller[key] = TextEditingController(text: value); }
   else
     { _textcontroller[key].text = value; }

    if(_statekey[key]!=null)
      { _statekey[key].currentState.setState(() {}); }
  }

}




