
import 'package:flutter/material.dart';
import '../vSpace.dart';
import '../vText.dart';
import '_Chatroom.dart';
import '_Send_query.dart';
import '../vSystem.dart';

class $$Chat_Send_Message extends StatefulWidget {
  var url;
  var sdata;
  var post;
  var onSuccess;
  var fontcolor;
  var bgcolor;

  var error = false;
  String error_message;
  var visible = 0.5;
  var api_loaded = false;

  Send_Query send_query;

  $$Chat_Send_Message({this.fontcolor,this.bgcolor,this.url,this.post,this.sdata,this.onSuccess,this.send_query,Key key}):super(key:key);

  @override
  _$EV_Send_MessageState createState() => _$EV_Send_MessageState();

}

class _$EV_Send_MessageState extends State<$$Chat_Send_Message> implements Send_Return {

  @override
  Widget build(BuildContext context) {
     if(!widget.api_loaded)
          { widget.api_loaded = true;
            var post = widget.post;
            post["message"] = widget.sdata["message"];
            widget.send_query.add(widget.url, widget.post, null, this);
          }

      if(widget.error)
          {  return Container(
               padding: EdgeInsets.all(5),
               //width: 140,
            child: Row(children: <Widget>[
                 vSp(0).expend(),
                 Icon(Icons.error,color: Colors.amber,size: 25,),
                 SizedBox(width: 5,),
                 //vText(Charroom_send_error[vSystem.$lang_id()]).s1(),
                 vText(widget.error_message).s1(),
            ],),
          );
          }
      else
        {  return Opacity(opacity: widget.visible,child: body(),); }
  }

  Widget body() {
    var  w = MediaQuery.of(context).size.width * 0.5 >500 ?  500  :MediaQuery.of(context).size.width * 0.5;
    return Card(
      child: ClipRRect(
          borderRadius: BorderRadius.circular(5.0),
          child: Stack(
            children: <Widget>[
              Container(
                padding: EdgeInsets.symmetric(horizontal: 10,vertical: 5),
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: <Widget>[
                    Text(widget.sdata["message"],
                      style: TextStyle(color: widget.fontcolor),),


                    SizedBox(height: 13,),
                  ],
                ),
                color: widget.bgcolor,
                constraints: BoxConstraints(
                  maxWidth: w,
                  minWidth: 100,
                ),
              ),

              Positioned(
                right: 5,
                bottom: 3,
                child: Text(widget.sdata["time"], style: TextStyle(fontSize: 10,
                    color: widget.fontcolor.withOpacity(0.7)),
                  textAlign: TextAlign.right,),
              ),
            ],
          )),
    );


  }
  @override
  void error_return(err_message) {
      setState(() {
        widget.error = true;
        widget.error_message = err_message;
      });
  }

  @override
  void process_return(send, total) {
    // TODO: implement process_return
  }

  @override
  void success_return(data) {
    //print("Get success reture " + widget.post.toString());
     setState(() {
        widget.visible = 1;
        widget.onSuccess(data);
     });

  }
}
