import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import 'vWeb.dart';

class $$WebScaffold extends StatelessWidget {
  Widget footer;
  bool body_under_appbar = true;

  @required Widget body;
  @required vWeb_AppBar appbar;

  ScrollController _scrollController = ScrollController();

  $$WebScaffold({Key key,this.appbar,this.body,this.footer,this.body_under_appbar = true}):super(key:key);

  @override
  Widget build(BuildContext context) {
    _scrollController.addListener(
     (){
      if (_scrollController.offset >= 100)
         {}
     });

    return  vWeb.$Responsive(
          Destop_app(context),
          child_Mobile: Mobile_app(context),
          child_Tablet: Table_app(context),
       );
   }

   Widget Mobile_app(BuildContext context)
   {  return Scaffold(
         appBar: AppBar(automaticallyImplyLeading: false, elevation: 2,
          leading:  Builder(
               builder: (context) => IconButton(icon:Icon(Icons.menu),iconSize:30, color: appbar.drawer_color,onPressed: (){
                 Scaffold.of(context).openDrawer();
               },),
             ),
         titleSpacing: 0,
          title: Row(
           mainAxisAlignment: MainAxisAlignment.spaceBetween,
           children: [
             GestureDetector(child: Image.asset(appbar.logo, height: 30),onTap: (){
               Navigator.popUntil(context, ModalRoute.withName('/'));
             },),
           ],
         ),
         backgroundColor: appbar.background_color),
         drawer: appbar.drawer,
         body: Stack(
           children: [
             SingleChildScrollView(
               controller: _scrollController,
               child: Column(children: [
                 body,
                 footer == null ? Container() : footer
               ],),
             ),
           ],
         )
       );
    }


   Widget Destop_app(BuildContext context)
   { print("Footer " + footer.toString());
     return SafeArea(
       child: SingleChildScrollView(
           controller: _scrollController,
           child: Container(
             color:Colors.teal,
             child: Stack(
               children: [
                 Column(children: [
                   SizedBox(height:body_under_appbar ? appbar.height : 0),
                   body,
                   Text("test"),
                   footer == null ? Container() : footer,
                   Text("footer")
                 ],),


                 Column(children: [
                   Container(width: double.infinity ,padding: appbar.padding,color: appbar.background_color,height: appbar.height,
                       child:Center(child:Container(width: appbar.width,
                         child: Row(children: [
                           Padding(
                             padding: const EdgeInsets.symmetric(horizontal:5 ),
                             child: Material(
                               color: Colors.transparent,
                               child: InkWell(
                                 hoverColor: Colors.transparent,
                                 highlightColor: Colors.transparent,
                                 splashColor: Colors.transparent,
                                    child:Image.asset(appbar.logo,height: 55,),onTap: (){
                                    Navigator.popUntil(context, ModalRoute.withName('/'));
                               },),
                             ),
                           ),
                           SizedBox(width: 10,),
                           Expanded(child:
                                appbar.center_widget == null ? Container() :
                                Center(child: appbar.center_widget)),
                                appbar.tail_widget == null ? Container() : appbar.tail_widget
                         ],),
                       ))),
                   ],),
               ],
             ),
           )
       ));
   }

  Widget Table_app(BuildContext context)
  { return SafeArea(
      child: SingleChildScrollView(
          controller: _scrollController,
          child: Stack(
            children: [
              Column(children: [
                SizedBox(height:body_under_appbar ? appbar.height : 0),
                body,
                footer == null ? Container() : footer
              ],),


              Column(children: [
                Container(width: double.infinity ,padding: appbar.padding,color: appbar.background_color,height: appbar.height,
                    child:Center(child:Container(width: appbar.width,
                      child: Row(children: [
                        Padding(
                          padding: const EdgeInsets.symmetric(horizontal:5 ),
                          child: Material(
                            color: Colors.transparent,
                            child: InkWell(
                              hoverColor: Colors.transparent,
                              highlightColor: Colors.transparent,
                              splashColor: Colors.transparent,
                              child:Image.asset(appbar.logo,height: 55,),onTap: (){
                              Navigator.popUntil(context, ModalRoute.withName('/'));
                            },),
                          ),
                        ),
                        SizedBox(width: 10,),
                        Expanded(child:
                           appbar.tail_widget == null ? Container() : appbar.tail_widget)
                      ],),
                    ))),
              ],),
            ],
          )
      ));
  }
}


