import 'package:ev_framework/_FrameWork/vBox.dart';
import 'package:ev_framework/_FrameWork/vSpace.dart';
import 'package:ev_framework/_FrameWork/vSystem.dart';
import 'package:ev_framework/_FrameWork/vText.dart';
import 'package:flutter/material.dart';
import 'package:carousel_pro/carousel_pro.dart';

class vTutorial extends StatefulWidget {
  var url;
  var eng = 0;
  var chi = 0;
  var chi_HK = 0;
  var chi_CN = 0;
  var default_lang = 0;
  var HomeWidget;
  var skip = ["Skip","Skip","跳過","跳过"];

  vTutorial({this.url,this.HomeWidget,this.default_lang = 0,this.eng=0,this.chi=0,this.chi_HK=0,this.chi_CN=0});

  @override
  _vTutorialState createState() => _vTutorialState();
}

class _vTutorialState extends State<vTutorial> {
  var lang_id = "0";
  var tskip = "";

  @override
  void initState() {
    // TODO: implement initState
    lang_id = widget.default_lang.toString();
    tskip = vSystem.$local("Tutorial");
    super.initState();
  }
  @override
  Widget build(BuildContext context) {
    if(tskip == "")
       return vBox().api_Box(widget.url,Tpage,postvalue: {"lang_id":lang_id}).c(Colors.black);
    else
      return widget.HomeWidget;
  }

  Widget Tpage(sdata)
  { var s = sdata["sdata"];
    if(s["photo"].length==0)
     {  return widget.HomeWidget; }

    return Stack(children: [
      Carousel(
       images: s["photo"].map<dynamic>((e) => NetworkImage(e)).toList(),
       boxFit: BoxFit.contain,
       showIndicator: true,
       dotSize: 7.0,
       dotSpacing: 20.0,
       dotColor: Colors.white,
       indicatorBgPadding: 10.0,
       dotBgColor: Colors.grey.withOpacity(0.0),
       autoplay: false,
      ),
      SafeArea(child: Padding(
        padding: const EdgeInsets.all(8.0),
        child: TpageButton(),
      )),

    ],);
  }

  Widget TpageButton()
  {  List<Widget> lang_btn = [];
     if(widget.eng==1)
       {  lang_btn.add(vText("English").cw().px(10).onPress((){
              setState(() {
                 lang_id = "1";
                 vSystem.$lang_Eng();
              });
          }));
       }

  if(widget.chi==1)
  {  lang_btn.add(vText("中文").cw().px(10).onPress((){
    setState(() {
      lang_id = "2";
      vSystem.$lang_Chi();
    });
  }));
  }

  if(widget.chi_CN==1)
  {  lang_btn.add(vText("簡体中文").cw().px(10).onPress((){
    setState(() {
      lang_id = "3";
      vSystem.$lang_Zh();
    });
  }));
  }

  if(widget.chi_HK==1)
  {  lang_btn.add(vText("繁體中文").cw().px(10).onPress((){
    setState(() {
      lang_id = "2";
      vSystem.$lang_Chi();
    });
    }));
   }

   return Row(children: [
     vSp(10),
     Row(children: lang_btn,),
     vSp(0).expend(),
     vText(widget.skip[int.parse(vSystem.$lang_id())]).cw().onPress((){
       setState(() {
         tskip = "1";
         vSystem.$local_Set("Tutorial","1");
       });
     }),
     vSp(10),
   ],);
  }
}
