import 'package:flutter/material.dart';

final Map<String,ValueNotifier<dynamic>> _Vbox_valuenotifier = Map();

class vBox_Notifier extends StatelessWidget {
  @required var sKey;
  @required var onBuild;
  @required var default_value;
  vBox_Notifier({this.sKey,this.default_value,this.onBuild});

  @override
  Widget build(BuildContext context) {
    if(_Vbox_valuenotifier[sKey] == null)
      {  _Vbox_valuenotifier[sKey] = ValueNotifier(default_value); }

    return ValueListenableBuilder<dynamic>(
          valueListenable:  _Vbox_valuenotifier[sKey],
          builder:(BuildContext context, value, Widget child) {
            return onBuild(value);
          }
    );
  }

  static $set_value(String skey,value) {
    if (_Vbox_valuenotifier[skey] != null) {
      _Vbox_valuenotifier[skey].value = value;
    }
  }
}




